一个活在命令行里的程序员给我们分享的代码

这篇内容源自 Github 上面一个有意思的分享。说的是这个分享者的一个前同事,作者说他是活在命令行中的人。只有要任何工作会耗费他 90 秒以上的时间,他就会写一个脚本来自动处理。

这位程序员写的这些脚本被收集整理后发到了 Github 上面,和大家一起分享,并且已经获得了 2 万多颗星星。

smack-my-bitch-up.sh: 这个脚本用于在加班的时候自动给他的老婆发短信。具体是怎么做到的呢,每天晚上 9 点的时候会检测这台电脑的命令行是否还在工作。如果命令行还在工作,就会从预置的三条信息中随机选一条发出去。

来看看他是怎么做到的:

#!/bin/sh -e

# Exit early if no sessions with my username are found
if ! who | grep -wq $USER; then
  exit
fi

# Phone numbers
MY_NUMBER='+xxx'
HER_NUMBER='+xxx'

REASONS=(
  'Working hard'
  'Gotta ship this feature'
  'Someone f ucked the system again'
)
rand=$[ $RANDOM % ${#REASONS[@]} ]

RANDOM_REASON=${REASONS[$rand]}
MESSAGE="Late at work. "$RANDOM_REASON

# Send a text message
RESPONSE=`curl -fSs -u "$TWILIO_ACCOUNT_SID:$TWILIO_AUTH_TOKEN" \
  -d "From=$MY_NUMBER" -d "To=$HER_NUMBER" -d "Body=$MESSAGE" \
  "https://api.twilio.com/2010-04-01/Accounts/$TWILIO_ACCOUNT_SID/Messages"`

# Log errors
if [ $? -gt 0 ]; then
  echo "Failed to send SMS: $RESPONSE"
  exit 1
fi

这个脚本中,先用 who 和 grep 命令检测当前正在工作的终端用户有没有自己,如果没有就直接退出,如果有则继续操作。 接下来预设一些变量,比如自己和老婆的电话号码,加班原因。 然后通过 curl 命令调用 api.twilio.com 的短信发送接口将信息发出去。

最后判断发送是否成功,如果发送失败,将日志打印出来。看起来挺复杂的操作,其实看看实际的脚本并不困难吧。

kumar-asshole.sh: 这个也很有意思,从邮箱的收件箱里面扫描一个叫 Kumar(公司一个客户的 DBA) 的人发来的邮件,从邮件的内容中确认是否包含 help,trouble,sorry 这类词语,如果包含,就自动通过 SSH 链接这个客户的数据库,并将数据库回滚到上一次备份。然后再回一封邮件说:“不要担心,下次注意就好。”

来看看这个脚本:

#!/usr/bin/env ruby

require 'dotenv'
require 'gmail'

Dotenv.load

GMAIL_USERNAME = ENV['GMAIL_USERNAME']
GMAIL_PASSWORD = ENV['GMAIL_PASSWORD']

GMAIL = Gmail.connect(GMAIL_USERNAME, GMAIL_PASSWORD)
KUMARS_EMAIL = 'kumar.a@example.com'

DB_NAME_REGEX  = /\S+_staging/
KEYWORDS_REGEX = /sorry|help|wrong/i

def create_reply(subject)
  GMAIL.compose do
    to KUMARS_EMAIL
    subject "RE: #{subject}"
    body "No problem. I've fixed it. \n\n Please be careful next time."
  end
end

GMAIL.inbox.find(:unread, from: KUMARS_EMAIL).each do |email|
  if email.body.raw_source[KEYWORDS_REGEX] && (db_name = email.body.raw_source[DB_NAME_REGEX])
    backup_file = "/home/backups/databases/#{db_name}-" + (Date.today - 1).strftime('%Y%m%d') + '.gz'
    abort 'ERROR: Backup file not found' unless File.exist?(backup_file)

    # Restore DB
    `gunzip -c #{backup_file} | psql #{db_name}`

    # Mark as read, add label and reply
    email.read!
    email.label('Database fixes')
    reply = create_reply(email.subject)
    GMAIL.deliver(reply)
  end
end

这个脚本是用 ruby 写的。 首先,调用 GMAIL.inbox.find 从收件箱中查找符合条件的邮件 — 发件人为 kumar.a@example.com,并且包含关键字 KEYWORDS_REGEX = /sorry|help|wrong/i。

如果找到相关邮件,先判断数据备份文件 backup_file 是否存在。 然后调用 gunzip 和 psql 命令还原这个备份。 最后调用 create_reply 方法创建回复邮件,并发出去。

这个脚本虽然说很方便,但还是比较依赖具体场景的。如果使用不得当也有可能会造成误还原等。当然它还是能帮我们打开一些思路的。

hangover.sh:又是一个定时通知的程序,这个在每天早上 8:45 的时候检测服务器的命令行中有没有自己登录,如果没有,自动给老板发短信请假。

代码如下:

#!/bin/sh -e

# Exit early if any session with my username is found
if who | grep -wq $USER; then
  exit
fi

# Phone numbers
MY_NUMBER='+xxx'
NUMBER_OF_BOSS='+xxx'

EXCUSES=(
  'Locked out'
  'Pipes broke'
  'Food poisoning'
  'Not feeling well'
)
rand=$[ $RANDOM % ${#EXCUSES[@]} ]

RANDOM_EXCUSE=${EXCUSES[$rand]}
MESSAGE="Gonna work from home. "$RANDOM_EXCUSE

# Send a text message
RESPONSE=`curl -fSs -u "$TWILIO_ACCOUNT_SID:$TWILIO_AUTH_TOKEN" \
  -d "From=$MY_NUMBER" -d "To=$NUMBER_OF_BOSS" -d "Body=$MESSAGE" \
  "https://api.twilio.com/2010-04-01/Accounts/$TWILIO_ACCOUNT_SID/Messages"`

# Log errors
if [ $? -gt 0 ]; then
  echo "Failed to send SMS: $RESPONSE"
  exit 1
fi

这个脚本基本逻辑和我们前面的差不多,就不多赘述了。

f ucking-coffee.sh:这个是这里面最有意思的脚本,脚本运行时会先等待 17 秒,然后通过 telnet 给咖啡机发送命令制作一个中杯拿铁咖啡。咖啡制作完成后,再等待 24 秒,然后把制作好的咖啡放到杯子里面。 这个整好是这个程序员从桌子走到咖啡机前的时间。

当然,前提是你得有一台可以联网并且接收命令的咖啡机。

脚本如下:

#!/usr/bin/env ruby

# Exit early if no sessions with my username are found
exit unless `who -q`.include? ENV['USER']

require 'net/telnet'

coffee_machine_ip = '10.10.42.42'
password = '1234'
password_prompt = 'Password: '
delay_before_brew = 17
delay = 24

sleep delay_before_brew
con = Net::Telnet.new('Host' => coffee_machine_ip)
con.cmd('String' => password, 'Match' => /#{password_prompt}/)
con.cmd('sys brew')
sleep delay
con.cmd('sys pour')
con.close

这个脚本也很好理解,首先判断当前用户是否登录,只有用户登录才会发送下面的命令给咖啡机。

脚本介绍完了,要让这些跑起来还需要做一些准备工作:

# used in `smack-my-bitch-up` and `hangover` scripts
TWILIO_ACCOUNT_SID=ACxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
TWILIO_AUTH_TOKEN=yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy

# used in `kumar_asshole` script
GMAIL_USERNAME=admin@example.org
GMAIL_PASSWORD=password

这个是设置 TWILIO 平台的 Key, 你需要注册一个,地址是 https://www.twilio.com
。 还需要按照上面的格式设置一下你的 GMAIL 用户名和密码。

然后还需要在 Cron 里面设置一下定时执行任务的规则:

# Runs `smack-my-bitch-up.sh` monday to friday at 9:20 pm.
20 21 * * 1-5 /path/to/scripts/smack-my-bitch-up.sh >> /path/to/smack-my-bitch-up.log 2>&1

# Runs `hangover.sh` monday to friday at 8:45 am.
45 8 * * 1-5 /path/to/scripts/hangover.sh >> /path/to/hangover.log 2>&1

# Runs `kumar-asshole.sh` every 10 minutes.
*/10 * * * * /path/to/scripts/kumar-asshole.sh

# Runs `f ucking-coffee.sh` hourly from 9am to 6pm on weekdays.
0 9-18 * * 1-5 /path/to/scripts/f ucking-coffee.sh

结束

看完这篇文章后,你是觉得这些脚本非常有创意,还是很无聊呢? 这个就见仁见智了。 不过这位有意思的程序员确实帮我们扩展了一下思路。命令行脚本能做的事情比我们平时想到的还要多。

加载余下内容▼

相关文章:

;